﻿/***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1/GPL 2.0/LGPL 2.1

The contents of this file are subject to the Mozilla Public License Version 
1.1 (the "License"); you may not use this file except in compliance with 
the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is easyGestures.

The Initial Developer of the Original Code is Ons Besbes.

Contributor(s):

Alternatively, the contents of this file may be used under the terms of
either the GNU General Public License Version 2 or later (the "GPL"), or
the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
in which case the provisions of the GPL or the LGPL are applicable instead
of those above. If you wish to allow use of your version of this file only
under the terms of either the GPL or the LGPL, and not to allow others to
use your version of this file under the terms of the MPL, indicate your
decision by deleting the provisions above and replace them with the notice
and other provisions required by the GPL or the LGPL. If you do not delete
the provisions above, a recipient may use your version of this file under
the terms of any one of the MPL, the GPL or the LGPL.

***** END LICENSE BLOCK *****/


// strings that must be changed
var eGSkin_PackageName = "egskin-modern";		// This is the name of the jar file. DON'T USE SPACES. ONLY USE ASCII CHARACTERS AND LOWER CASE !
var eGSkin_DisplayName="Modern Skin 1.1.1";
var eGSkin_InstallID = "egskin-modern@mozilla.org"
var eGskinsPacksFolder = "skins packs"
var eGID = "{11F9F076-72B3-4586-995D-5042CF5D3AD4}"


// don't change anything starting from here

// File constants copied from file-utils.js
const MODE_WRONLY   = 0x02;
const MODE_APPEND   = 0x10;

var eGSkin_fileLocator = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);				
var eGSkin_userProfilePath =eGSkin_fileLocator.get("ProfD", Components.interfaces.nsIFile).path;

window.addEventListener("load", eGSkin_installSkin, false);
window.addEventListener("unload", eGSkin_uninstallAddon, false);

function eGSkin_installSkin(evt) {	
    
    try {
    
        // create "skins packs" skinDisplayName folders into eG's chrome folder
        var destinationFolder=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        destinationFolder.initWithPath(eGSkin_userProfilePath);
        destinationFolder.append("extensions");
        destinationFolder.append(eGID);
        destinationFolder.append("chrome");
        destinationFolder.append(eGskinsPacksFolder);
        errMsg = "Failed to create folder skins packs. Installation failed."
        if (!destinationFolder.exists()) {  //create folder "skins packs".
            destinationFolder.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);  
        }
        errMsg = "Failed to create folder" + eGSkin_DisplayName + ". Installation failed."
        destinationFolder.append(eGSkin_DisplayName);  //create folder eGSkin_DisplayName.
        destinationFolder.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
        
        // copy skinPackageName.jar file into eG's skinDisplayName folder
        var jarToCopy=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        jarToCopy.initWithPath(eGSkin_userProfilePath);
        jarToCopy.append("extensions");
        jarToCopy.append(eGSkin_InstallID);
        jarToCopy.append("chrome");			
        jarToCopy.append(eGSkin_PackageName+".jar");
        errMsg = "Failed to copy jar file. Installation failed."
        jarToCopy.copyTo(destinationFolder, eGSkin_PackageName +".jar");    
        
        // register chrome: add entries in eG.s manifest
        
        // append to chrome.manifest in eG's folder the two following strings:
        var str1 = "content " + eGSkin_PackageName + " jar:chrome/"+ escape(eGskinsPacksFolder) +"/" + escape(eGSkin_DisplayName) + "/" + eGSkin_PackageName +".jar!/content/ contentaccessible=yes" 
        var str2 = "skin "+ eGSkin_PackageName + " classic/1.0 jar:chrome/" + escape(eGskinsPacksFolder) + "/" + escape(eGSkin_DisplayName) + "/" + eGSkin_PackageName +".jar!/skin/classic/"
        
        // cross platform append
        var manisfestFile=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        manisfestFile.initWithPath(eGSkin_userProfilePath);
        manisfestFile.append("extensions");
        manisfestFile.append(eGID);
        manisfestFile.append("chrome.manifest");
            
        // prepare for writing to chrome.manifest
		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance();
		outputStream = outputStream.QueryInterface(Components.interfaces.nsIFileOutputStream);
		outputStream.init(manisfestFile, MODE_WRONLY | MODE_APPEND, 0664, false);    // open write+append
		outputStream.write("\n\n",2);
        outputStream.write(str1, str1.length);
        outputStream.write("\n",1);
        outputStream.write(str2, str2.length);
        outputStream.close();
        
        //logMessage("Skin installation succesfull.");

    } catch(ex) {
        logMessage(errMsg);
        logMessage(ex);
    }
    
}

function eGSkin_uninstallAddon(evt)	{
    try { // delete skin installation addon because no more needed
    
        errMsg = "Failed to delete skin installation addon."       
        Components.utils.import("resource://gre/modules/AddonManager.jsm");
        AddonManager.getAddonByID(eGSkin_InstallID, function(addon) {addon.uninstall();});
        
	} catch(ex) {
        logMessage(errMsg);
        logMessage(ex);   
    }
}

function logMessage (message) {
	Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService).logStringMessage(message);
}